#include <signal.h>
#include <stdio.h>
#include <stdlib.h>

static void sigbus_handler(int ignored)
{
  fprintf(stderr, "Got SIGBUS exception.\n");
  exit(1);
}

int main()
{
  int *p = (int *)0x100000;

  signal(SIGBUS, sigbus_handler);

  fprintf(stderr, "Triggering SIGBUS exception (invalid read):\n");
  printf("*p is: %d\n", *p);
  fprintf(stderr, "Exception didn't trigger.\n");

  return 0;
}
