#include <signal.h>
#include <stdio.h>
#include <stdlib.h>

static void sigbus_handler(int ignored)
{
  fprintf(stderr, "Got SIGBUS exception.\n");
  exit(1);
}

static char buffer[16];

int main()
{
  int *p = (int *)(&buffer[1]); /* Create unaligned pointer. */

  signal(SIGBUS, sigbus_handler);

  fprintf(stderr, "Triggering SIGBUS exception (unaligned read):\n");
  printf("*p is: %d\n", *p);
  fprintf(stderr, "Exception didn't trigger.\n");

  return 0;
}
